# **References**

## *Branch and Bound*
- Floudas, Christodoulos A. Deterministic global optimization: theory, methods and applications. Vol. 37. Springer Science & Business Media, 2013.
- Horst, Reiner, and Hoang Tuy. Global optimization: Deterministic approaches. Springer Science & Business Media, 2013.

## *Parametric Interval Techniques*
- E. R. Hansen and G. W. Walster. Global Optimization Using Interval Analysis. Marcel Dekker, New York, second edition, 2004.
- R. Krawczyk. Newton-algorithmen zur bestimmung con nullstellen mit fehler-schranken. *Computing*, 4:187–201, 1969.
- R. Krawczyk. Interval iterations for including a set of solutions. *Computing*, 32:13–31, 1984.
- C. Miranda. Un’osservatione su un teorema di brower. *Boll. Un. Mat. Ital.*, 3:5–7, 1940.
- A. Neumaier. Interval Methods for Systems of Equations. Cambridge University Press, Cambridge, 1990.
- R. E. Moore. A test for existence of solutions to nonlinear systems. *SIAM Journal on Numerical Analysis*, 14(4):611–615, 1977.

## *Domain Reduction*
- Benhamou, F., & Older, W.J. (1997). Applying interval arithmetic to real, integer, and boolean constraints. *The Journal of Logic Programming*, 32, 1–24.
- Caprara, A., & Locatelli, M. (2010). Global optimization problems and domain reduction strategies. *Mathematical Programming*, 125, 123–137.
- Gleixner, A.M., Berthold, T., Müller, B., & Weltge, S. (2016). Three enhancements for optimization-based bound tightening. ZIB Report, 15–16.
- Ryoo, H.S., & Sahinidis, N.V. (1996). A branch-and-reduce approach to global optimization. *Journal of Global Optimization*, 8, 107–139.
- Schichl, H., & Neumaier, A. (2005). Interval analysis on directed acyclic graphs for global optimization. *Journal of Global Optimization*, 33, 541–562.
- Tawarmalani, M., & Sahinidis, N.V. (2005). A polyhedral branch-and-cut approach to global optimization. *Mathematical Programming*, 103, 225–249.
- Vu, X., Schichl, H., & Sam-Haroud, D. (2009). Interval propagation and search on directed acyclic graphs for numerical constraint solving. *Journal of Global Optimization*, 45, 499–531.

## *Generalized McCormick Relaxations*
- Chachuat, B.: MC++: a toolkit for bounding factorable functions, v1.0. Retrieved 2 July 2014 https://projects.coin-or.org/MCpp (2014)
- A. Mitsos, B. Chachuat, and P. I. Barton. McCormick-based relaxations of algorithms. *SIAM Journal on Optimization*, 20(2):573–601, 2009.
- G. P. McCormick. Computability of global solutions to factorable nonconvex programs: Part I-Convex underestimating problems. *Mathematical Programming*, 10:147–175, 1976.
- G. P. McCormick. Nonlinear programming: Theory, Algorithms, and Applications. Wiley, New York, 1983.
- J. K. Scott, M. D. Stuber, and P. I. Barton. Generalized McCormick relaxations. *Journal of Global Optimization*, 51(4):569–606, 2011.
- Stuber, M.D., Scott, J.K., Barton, P.I.: Convex and concave relaxations of implicit functions. *Optim. Methods Softw.* 30(3), 424–460 (2015)
- A. Tsoukalas and A. Mitsos. Multivariate McCormick Relaxations. *Journal of Global Optimization*, 59:633–662, 2014.

## *Semi-Infinite Programming*
- A. Mitsos. Global optimization of semi-infinite programs via restriction of the right-hand side. *Optimization*, 60(10-11):1291-1308, 2009.
- Stuber, M.D. and Barton, P. I. Semi-Infinite Optimization With Implicit Functions. *Industrial & Engineering Chemistry Research*, 54:307-317, 2015.
